Imports System.Threading

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnStartThread As System.Windows.Forms.Button
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtResults As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnStartThread = New System.Windows.Forms.Button
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtResults = New System.Windows.Forms.TextBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'btnStartThread
        '
        Me.btnStartThread.Location = New System.Drawing.Point(8, 160)
        Me.btnStartThread.Name = "btnStartThread"
        Me.btnStartThread.TabIndex = 0
        Me.btnStartThread.Text = "Start Thread"
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(8, 40)
        Me.TextBox1.Multiline = True
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(280, 112)
        Me.TextBox1.TabIndex = 2
        Me.TextBox1.Text = ""
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(280, 32)
        Me.Label1.TabIndex = 3
        Me.Label1.Text = "Notice that you can interact with the form (for example, enter text in the TextBo" & _
        "x) while the thread is running."
        '
        'txtResults
        '
        Me.txtResults.Location = New System.Drawing.Point(0, 208)
        Me.txtResults.Multiline = True
        Me.txtResults.Name = "txtResults"
        Me.txtResults.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtResults.Size = New System.Drawing.Size(288, 104)
        Me.txtResults.TabIndex = 4
        Me.txtResults.Text = ""
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(0, 192)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(72, 16)
        Me.Label2.TabIndex = 5
        Me.Label2.Text = "Results:"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 317)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.txtResults)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.TextBox1)
        Me.Controls.Add(Me.btnStartThread)
        Me.Name = "Form1"
        Me.Text = "howto_net_thread_use_form"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' This value is incremented by the thread.
    Public Value As Integer = 0

    Private Sub btnStartThread_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartThread.Click
        ' Make a new counter object.
        Static thread_num As Integer = 0
        Dim new_counter As New Counter(Me, thread_num)
        thread_num += 1

        ' Make a thread to run the object's Run method.
        Dim counter_thread As New Thread(AddressOf new_counter.Run)

        ' Make this a background thread so it automatically
        ' aborts when the main program stops.
        counter_thread.IsBackground = True

        ' Start the thread.
        counter_thread.Start()
    End Sub

    ' Add the text to the results.
    ' The form provides this service because the
    ' thread cannot access the form's controls directly.
    Public Sub DisplayValue(ByVal txt As String)
        txtResults.Text &= vbCrLf & txt
        txtResults.Select(txtResults.Text.Length - 1, 0)
        txtResults.ScrollToCaret()
    End Sub
End Class

' This class's Run method displays a count in the Output window.
Public Class Counter
    ' The form that owns the Value variable.
    Private m_MyForm As Form1

    ' Define a delegate type for the form's DisplayValue method.
    Private Delegate Sub DisplayValueDelegateType(ByVal txt As String)

    ' Declare a delegate variable to point
    ' to the form's DisplayValue method.
    Private m_DisplayValueDelegate As DisplayValueDelegateType

    ' This counter's number.
    Private m_Number As Integer

    Public Sub New(ByVal my_form As Form1, ByVal my_number As Integer)
        m_MyForm = my_form
        m_Number = my_number

        ' Initialize the delegate variable to point
        ' to the form's DisplayValue method.
        m_DisplayValueDelegate = AddressOf m_MyForm.DisplayValue
    End Sub

    ' Count off seconds in the Output window.
    Public Sub Run()
        Try
            Do
                ' Wait 1 second.
                Thread.Sleep(1000)

                ' Lock the form object. This doesn't do anything
                ' to the form, it just means no other thread can
                ' lock the form object until we release the lock.
                ' That means a thread can update m_MyForm.Value
                ' and then display its value without interference.
                SyncLock m_MyForm
                    ' Increment the form's Value.
                    m_MyForm.Value += 1

                    ' Display the value on the form.
                    ' The call to InvokeRequired returns True
                    ' if this code is not running on the same
                    ' thread as the object m_MyForm. In this
                    ' example, we know that is true so the call
                    ' isn't necessary, but in other cases it
                    ' might not be so clear.
                    If m_MyForm.InvokeRequired() Then
                        ' Make an array containing the parameters
                        ' to pass to the method.
                        Dim args() As String = {m_Number & ": " & m_MyForm.Value}

                        ' Invoke the delegate.
                        m_MyForm.Invoke(m_DisplayValueDelegate, args)
                    End If
                End SyncLock
            Loop
        Catch ex As Exception
            ' An unexpected error.
            Debug.WriteLine("Unexpected error in thread " & _
                m_Number & vbCrLf & ex.Message)
        End Try
    End Sub

End Class
